#include <stdio.h>
#include <a.out.h>

#define DEBUG


main( argc, argv )
int argc;
char *argv[];
{
	FILE *fp;
	struct exec ExecHdr;
	int offset;
	int num_syms;
	int i, Index;
	struct nlist sym;
	char *name;
	char *SymbolName;
	char *StringTable;
	int StringSize;

	if ( argc < 3 ){
		fprintf( stderr, "Usage: tostatic <filename> <symbol>...\n" );
		exit(-1);
	}
	fp = fopen( argv[1], "r+" );
	if ( fread( &ExecHdr, sizeof(ExecHdr), 1, fp ) != 1 ){
		fprintf( stderr, "Could not read file header\n" );
		exit(-1);
	}
	DEBUG( "Magic %x Size %x %x %x %x %x %x\n",
		ExecHdr.a_magic, ExecHdr.a_text,
		ExecHdr.a_data, ExecHdr.a_bss,
		ExecHdr.a_syms, ExecHdr.a_trsize,
		ExecHdr.a_drsize );
	offset = sizeof(ExecHdr)+
		 ExecHdr.a_text +
		 ExecHdr.a_data +
		 ExecHdr.a_trsize +
		 ExecHdr.a_drsize;
	DEBUG( "Offset %x\n", offset);
	num_syms = ExecHdr.a_syms / (sizeof(struct nlist));
	DEBUG( "NumSymbols %d\n", num_syms );
	fseek( fp, offset+ExecHdr.a_syms, 0 );
	fread( &StringSize, sizeof(long), 1, fp );
	DEBUG( "StringSize %d\n", StringSize );
	StringTable = (char *)malloc( StringSize * sizeof(char));
	if ( StringTable == NULL ){
		fprintf( stderr, "Could not allocate memory for String Table\n" );
		exit(-1);
	}
	*(long *)StringTable = StringSize;
	fread( StringTable+4, sizeof(char), StringSize, fp );
	DEBUG( "Strings %x %x %x %x\n", StringTable[0], StringTable[1], StringTable[2], StringTable[3] );
	for ( Index = 2; Index < argc; Index ++ ){
		SymbolName = argv[Index];
		fseek( fp, offset, 0 );
		for ( i = 0; i < num_syms; i++ ){
			fread( &sym, sizeof( struct nlist ), 1, fp );
			DEBUG( "Sym %x %x\n", sym.n_un.n_strx, sym.n_type );
			DEBUG( "sym %s\n", &(StringTable[sym.n_un.n_strx]) );
			name = &(StringTable[sym.n_un.n_strx]);
			if ( strcmp( name, SymbolName ) == 0 ){
				sym.n_type &= 0xfe;
				DEBUG( "Convert %s to static; type %x\n", name, sym.n_type );
				fseek( fp, -sizeof( struct nlist ), 1 );
				fwrite( &sym, sizeof( struct nlist ), 1, fp );
				break;
			}
		}
	}
	fseek( fp, 0, 2 );

	fclose(fp);
	exit(0);
}


